<?php

require_once DOL_DOCUMENT_ROOT . '/core/class/html.formfile.class.php';
require_once DOL_DOCUMENT_ROOT . '/core/class/html.formmargin.class.php';
require_once DOL_DOCUMENT_ROOT . '/core/lib/functions.lib.php';
require_once DOL_DOCUMENT_ROOT . '/comm/propal/class/propal.class.php';
require_once DOL_DOCUMENT_ROOT . '/commande/class/commande.class.php';
require_once DOL_DOCUMENT_ROOT . '/compta/facture/class/facture.class.php';
require_once DOL_DOCUMENT_ROOT . '/product/class/product.class.php';
require_once DOL_DOCUMENT_ROOT.'/core/class/doleditor.class.php';
require_once(DOL_DOCUMENT_ROOT."/core/lib/admin.lib.php");
dol_include_once('/ouvrage/class/ouvrage.class.php');

global $langs, $user, $db, $conf, $mysoc;

$langs->load("ouvrage@ouvrage");
$langs->load("products");
$langs->load("stocks");

$listPrefixEcotax = [];

if (!empty($conf->global->OUVRAGE_LIST_PREFIX_ECOTAX)) {
	$listPrefixEcotax = trim($conf->global->OUVRAGE_LIST_PREFIX_ECOTAX);
	$listPrefixEcotax = explode(',', $listPrefixEcotax);
}

if (!empty($conf->margin->enabled)) {
	$langs->load('margins');
}

$form = new Form($db);
$formmargin = new FormMargin($db);

$reduc = 0;
$product = new Product($db);
$product->fetch($det['id']);
$product->load_stock(); // InfraS add
$pu_ht = $ouvrage->getPrice($product, $object);
$object->fetch_optionals();
if ($object->array_options['options_isSitePropal'] && dolibarr_get_const($db, 'OUVRAGE_SITE', $conf->entity) == 1) {
	$product->fetch_optionals();
	$qtySite = $product->array_options['options_qty'];
	$reduc = 0;
	// COMPTATIBILITE MODULE DISCOUNT RULE : RECHERCHE DE REGLE DE TARIFICATION
	if (!empty($conf->discountrules->enabled) ){
		if(!class_exists('DiscountSearch')){ dol_include_once('/discountrules/class/discountSearch.class.php'); }
		if(class_exists('DiscountSearch')) { // Il est possible que le module soit supprimé mais pas désinstallé
			$discountSearch = new DiscountSearch($db);
			$subprice = DiscountRule::getProductSellPrice($product->id, $object->thirdparty->id);
			$discountSearchResult = $discountSearch->search('0', $product->id, $object->thirdparty->id, $object->fk_project);
			if ($discountSearchResult->result) {
				// Mise en page du résultat
				$discountSearchResult->tpMsg = getDiscountRulesInterfaceMessageTpl($langs, $discountSearchResult, $action);
				$subprice = $discountSearchResult->subprice;
				$finalSubprice = $discountSearchResult->calcFinalSubprice();
				if (!empty($discountSearchResult->reduction)) {
					$reduc = $discountSearchResult->reduction;
				}
			}
		}
		else{
			setEventMessage($langs->trans('ErrorMissingModuleDiscountRule'));
		}
	}
	$cond_id = 0;
	$cond = $product->array_options['options_cond'];
	if (!empty($cond)) {
		$sql = 'SELECT r.rowid FROM '.MAIN_DB_PREFIX.'c_units r WHERE short_label = "'.$cond.'"';
		$resql = $db->query($sql);
		$obj = $db->fetch_object($resql);
		$cond_id = $obj->rowid;
	}


	if(!empty($subprice)) {
		$pu_ht = $subprice;
	}
	if (!empty($qtySite)) {
		$pu_ht = round(($pu_ht /$qtySite),$conf->global->MAIN_MAX_DECIMALS_TOT);
	}
}
if (!empty($object->thirdparty->remise_percent)) {
	$reduc = $object->thirdparty->remise_percent;
}

$colspan = !empty($conf->global->PRODUCT_USE_UNITS) ? 9 : 10;
$colspan += !empty($conf->margin->enabled) && $user->rights->margins->creer ? 1 : 0;
$colspan += !empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX) ? 1 : 0;
?>

<table id="tablelinesouvrage" class="tagtable liste listwithfilterbefore noborder" width="100%">
	<thead>
	<tr class="liste_titre nodrag nodrop">
		<th class="linecoldescription liste_titre center"><?php print $langs->trans('Product') ?></th>
		<th class="linecoldescription liste_titre center"><?php print $langs->trans('Label') ?></th>
		<th class="linecoldescription liste_titre center"><?php print $langs->trans('Description') ?></th>
		<th class="linecolstock liste_titre center"><?php print $langs->trans('RealStock') ?></th>
		<th class="linecolvat liste_titre center"><?php print $langs->trans('VAT') ?></th>
		<th class="linecoluht liste_titre center"><?php print $langs->trans('PriceUHT') ?></th>
		<th class="linecolqty liste_titre center"><?php print $langs->trans('Qty') ?></th>
		<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
			<th class="linecolvat liste_titre center"><?php print $langs->trans('Unit') ?></th>
		<?php } ?>
		<th class="linecoldiscount liste_titre center"><?php print $langs->trans('Discount') ?></th>
		<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
			<th class="linecolmargin1 margininfos liste_titre center"><?php print $langs->trans('CostPrice') ?></th>
		<?php } ?>
		<th class="linecolht liste_titre center"><?php print $langs->trans('TotalHT') ?></th>
		<?php if (!empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX)) { ?>
			<th class="liste_titre">&nbsp;</th>
		<?php } ?>
	</tr>
	<tr class="liste_titre_filter">
		<input type="hidden" name="ouvrage[desc]" value="<?php print htmlentities($ouvrage->description, ENT_QUOTES, 'UTF-8') ?>"/>
		<input type="hidden" name="ouvrage[id]" value="<?php print $ouvrage->id ?>"/>
		<td class="liste_titre"><?php print $ouvrage->ref ?></td>
		<td class="liste_titre"><?php print $ouvrage->label ?></td>
		<td class="liste_titre" onmouseover='$("#modal-ouvrage .cke_top").css("display", "block")', onmouseout='fillOuvrageDescTextArea();$("#modal-ouvrage .cke_top").css("display", "none");'>
			<style>
				#modal-ouvrage .cke_top {
					display: none;
				}
			</style>
			<?php
			$doleditor = new DolEditor('ouvrageDescription', $ouvrage->description, '400', '150', 'dolibarr_details', 'In', false, true, $conf->global->FCKEDITOR_ENABLE_PRODUCTDESC, ROWS_4, '90%');
			$doleditor->Create();
			?>
		</td>
		<td class="liste_titre">&nbsp;</td>
		<td class="liste_titre right">
			<?php if (empty($conf->global->OUVRAGE_USE_LINE_VAT)) {
				if ($object->thirdparty->tva_assuj) {
					$tva_tx = $ouvrage->fk_tva;
				} else {
					$tva_tx = 0;
				}

				?>
				<input type="hidden"
					   value="<?php print $ouvrage->fk_product; ?>"/><?php print $form->load_tva("tva_tx_ouvrage",
					$tva_tx, $mysoc, ''); ?>
			<?php } ?>
		</td>
		<td class="ouvrage-parent-price-unit liste_titre right"><?php print price2num($ouvrage->unitPrice, 'MT') ?></td>
		<td class="right"><input type="number" class="right" data-default="<?php print 1 ?>" name="ouvrage[qty]" value="1" size="2"
								 step="<?php print $conf->global->OUVRAGE_QUANTITY_STEP ?>" min="0"
								 style="max-width: 75px;"/></td>
		<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
			<td class="liste_titre"><?php print $form->selectUnits($ouvrage->fk_unit, "ouvrage[unit]", 0); ?></td>
		<?php } ?>
		<td class="liste_titre right"><input type="number" class="right" name="ouvrage[reduc]"
											 value="<?php print $reduc ?>" size="2" step="0.01" min="0" max="100"
											 style="max-width: 50px;"/><span class="hideonsmartphone">%</span></td>
		<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
			<td class="liste_titre right"><input type="number" class="right" name="ouvrage[marge]" disabled="disabled"
												 min="0" value="0" style="max-width: 100px;"/></td>
		<?php } ?>
		<td class="ouvrage-parent-price-total<?php $ouvrage->id ?> liste_titre right">0</td>
		<?php if (!empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX)) { ?>
			<td class="liste_titre">&nbsp;</td>
		<?php } ?>
	</tr>
	</thead>
	<tbody>
	<?php
	$i = 1;
	foreach ($lines as $det) {
	if ($det['element'] == "ouvrage") { ?>
		<tr class="liste_titre_filter">
			<input type="hidden" name="ouvrages[<?php print $i ?>][desc]"
				   value="<?php print $det['ouvrage']->description ?>"/>
			<input type="hidden" name="ouvrages[<?php print $i ?>][type]" value="ouvrage"/>
			<input type="hidden" id="ouvrages-id-<?php print $i ?>" name="ouvrages[<?php print $i ?>][id]" value="<?php print $det['ouvrage']->id ?>"/>
			<input type="hidden" name="ouvrages[<?php print $i ?>][ref]" value="<?php print $det['ouvrage']->ref ?>"/>
			<input type="hidden" name="ouvrages[<?php print $i ?>][label]" value="<?php print $det['ouvrage']->label ?>"/>
			<input type="hidden" id="ouvrages-<?php print $i ?>-pu" name="ouvrages[<?php print $i ?>][pu]" value="<?php print $det['ouvrage']->unitPrice ?>"/>
			<td class="liste_titre"><?php print $det['ouvrage']->ref ?></td>
			<td class="liste_titre"><?php print $det['ouvrage']->label ?></td>
			<td class="liste_titre"></td>
			<td class="liste_titre">&nbsp</td>
			<td class="liste_titre right">
				<?php if (empty($conf->global->OUVRAGE_USE_LINE_VAT)) {
					if ($object->thirdparty->tva_assuj) {
						$tva_tx = $ouvrage->fk_tva;
					} else {
						$tva_tx = 0;
					}
					?>
					<input type="hidden" value="<?php print $det['ouvrage']->fk_product; ?>"/><?php print $form->load_tva("ouvrages[tva][". $i ."]", $tva_tx, $mysoc, ''); ?>
				<?php } ?>
			</td>
			<td class="ouvrage-price-unit<?php print $det['ouvrage']->id ?> liste_titre right"><?php print price2num($det['ouvrage']->unitPrice,
					'MT') ?></td>
			<td class="right">
				<input type="number" data-default="<?php print $det['ouvrage']->qty ?>" class="right" id="ouvrages-qty-<?php print $det['ouvrage']->id ?>" name="ouvrages[<?php print $i ?>][qty]" value="<?php  print $det['ouvrage']->qty?>"
									 size="2"
									 step="<?php print $conf->global->OUVRAGE_QUANTITY_STEP ?>" min="0"
									 style="max-width: 75px;"/></td>
			<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
				<td class="liste_titre"><?php print $form->selectUnits($det['ouvrage']->fk_unit,
						"ouvrages[" . $i . "][unit]",
						0); ?></td>
			<?php } ?>
			<td class="liste_titre right">
				<input type="number" class="right" id="ouvrages[reduc][<?php print $i ?>]" name="ouvrages[<?php print $i ?>][reduc]"
												 value="<?php print $reduc ?>" size="2" step="0.01" min="0" max="100"
												 style="max-width: 50px;"/><span class="hideonsmartphone">%</span></td>
			<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
				<td class="liste_titre right"><input type="number" class="right"
													 name="ouvrages[<?php print $i ?>][marge]"
													 disabled="disabled"
													 min="0" value="0" style="max-width: 100px;"/></td>
			<?php } ?>
			<td class="ouvrage-price-total<?php print $det['ouvrage']->id ?> liste_titre right"><?php  print price2num((($det['ouvrage']->unitPrice * $det['ouvrage']->qty) - ($det['ouvrage']->unitPrice * ($reduc / 100) * $det['ouvrage']->qty)), 'MT') ?></td>
			<?php if (!empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX)) { ?>
				<td class="liste_titre">&nbsp;</td>
			<?php } ?>
		</tr>
		<?php if ($det['ouvrage']->id != $ouvrage->id) { ?>
		<script>
			console.log("debut script 2")
			$(document).on('change', 'input[name="ouvrages[<?php print $i ?>][reduc]"]', function(e){
				$('#tablelinesouvrage input[id="product-reduc<?php print $det['ouvrage']->id ?>"]').val($(this).val());
				$('#tablelinesouvrage input[id="product-reduc<?php print $det['ouvrage']->id ?>"]').trigger('change');
				calculTotalOuvrage<?php print $det['ouvrage']->id ?>();
			});

			$(document).on('change', 'select[id*="ouvrages[tva][<?php print $i ?>]"]', function(e){
				$('#tablelinesouvrage td.product-tva<?php print $det['ouvrage']->id ?>').html($(this).val());
			});

			$("#ouvrages-qty-<?php print $det['ouvrage']->id ?>").change(function () {
				var qtyOuvrage = $(this).val();
				$('#tablelinesouvrage #product-quantity-<?php print $det['ouvrage']->id ?>').each(function(){
					$(this).val(qtyOuvrage*$(this).data('default') );
					$(this).trigger('change');
				});
			});

			function calculTotalOuvrage<?php print $det['ouvrage']->id ?>() {
				var totalOuvrage = 0;
				$('#tablelinesouvrage td.product-price-total<?php print $det['ouvrage']->id ?>').each(function () {
					// InfraS add begin
					if (useCheckboxes == 1) {
						var validProduct = $(this).parents('tr').find('td.product-check input[type="hidden"]').val();
						if (validProduct == 1) {
							totalOuvrage += parseFloat($(this).text().replace(',', '.').replace(' ', ''));
						}
					} else {
						// InfraS add end
						totalOuvrage += parseFloat($(this).text().replace(',', '.').replace(' ', ''));
					}	// InfraS add
				}).promise().done(function () {
					let reduc = 1 - ($('#tablelinesouvrage input[id="product-reduc<?php print $det['ouvrage']->id ?>"]').val() / 100 );
					var totalOuvrageUnit = parseFloat((totalOuvrage / reduc ) / $("#ouvrages-qty-<?php print $det['ouvrage']->id ?>").val() ).toFixed(<?php print $conf->global->MAIN_MAX_DECIMALS_TOT ?>);
					totalOuvrage= parseFloat((totalOuvrage )).toFixed(<?php print $conf->global->MAIN_MAX_DECIMALS_TOT ?>);

					$('#tablelinesouvrage td.ouvrage-price-total<?php print $det['ouvrage']->id ?>').text(totalOuvrage);
					$('#tablelinesouvrage td.ouvrage-price-unit<?php print $det['ouvrage']->id ?>').text(totalOuvrageUnit);
					$("#ouvrages-<?php print $i ?>-pu").val(totalOuvrageUnit);
				});

				var prixRevientOuvrage = 0;
				if ($('input[name="ouvrages[<?php print $i ?>][marge]"]').length > 0) {
					$('#tablelinesouvrage td.product-marge<?php print $det['ouvrage']->id ?> input').each(function () {
						var qtyProduct = $(this).parents('tr').find('td.product-qty input').val();

						if (useCheckboxes == 1) {
							var validProduct = $(this).parents('tr').find('td.product-check input[type="hidden"]').val();
							if (validProduct == 1) {
								if ($(this).val() > 0) {
									prixRevientOuvrage += parseFloat($(this).val()) * qtyProduct;
								} else {
									prixRevientOuvrage += 0;
								}
							}
						} else {
							if ($(this).val().length > 0) {
								prixRevientOuvrage += parseFloat($(this).val()) * qtyProduct;
							} else {
								prixRevientOuvrage += 0;
							}
						}
					});

					prixRevientOuvrage = isNaN(prixRevientOuvrage) ? 0 : prixRevientOuvrage;
					$('input[name="ouvrages[<?php print $i ?>][marge]"]').val(parseFloat(prixRevientOuvrage).toFixed(<?php print $conf->global->MAIN_MAX_DECIMALS_TOT ?>));
				}
			}
		</script>
	<?php
	}
	$i++;
	}

	if ($det['element'] == "product") {
	$product = new Product($db);
	$product->fetch($det['id']);
	$product->load_stock(); // InfraS add
	$pu_ht = $ouvrage->getPrice($product, $object);
	$object->fetch_optionals();
    if ($object->array_options['options_isSitePropal'] && dolibarr_get_const($db, 'OUVRAGE_SITE', $conf->entity) == 1) {
		$product->fetch_optionals();
		$qtySite = $product->array_options['options_qty'];
		$reduc = 0;
		// COMPTATIBILITE MODULE DISCOUNT RULE : RECHERCHE DE REGLE DE TARIFICATION
		if (!empty($conf->discountrules->enabled) ){
			if(!class_exists('DiscountSearch')){ dol_include_once('/discountrules/class/discountSearch.class.php'); }
			if(class_exists('DiscountSearch')) { // Il est possible que le module soit supprimé mais pas désinstallé
				$discountSearch = new DiscountSearch($db);
				$subprice = DiscountRule::getProductSellPrice($product->id, $object->thirdparty->id);
				$discountSearchResult = $discountSearch->search('0', $product->id, $object->thirdparty->id, $object->fk_project);
				if ($discountSearchResult->result) {
					// Mise en page du résultat
					$discountSearchResult->tpMsg = getDiscountRulesInterfaceMessageTpl($langs, $discountSearchResult, $action);
					$subprice = $discountSearchResult->subprice;
					$finalSubprice = $discountSearchResult->calcFinalSubprice();
					if (!empty($discountSearchResult->reduction)) {
						$reduc = $discountSearchResult->reduction;
					}
				}
			}
			else{
				setEventMessage($langs->trans('ErrorMissingModuleDiscountRule'));
			}
		}
		$cond_id = 0;
		$cond = $product->array_options['options_cond'];
		if (!empty($cond)) {
			$sql = 'SELECT r.rowid FROM '.MAIN_DB_PREFIX.'c_units r WHERE short_label = "'.$cond.'"';
			$resql = $db->query($sql);
			$obj = $db->fetch_object($resql);
			$cond_id = $obj->rowid;
		}


		if(!empty($subprice)) {
			$pu_ht = $subprice;
		}
		if (!empty($qtySite)) {
			$pu_ht = round(($pu_ht /$qtySite),$conf->global->MAIN_MAX_DECIMALS_TOT);
		}
	}
	if (!empty($object->thirdparty->remise_percent)) {
		$reduc = $object->thirdparty->remise_percent;
	}
	/*$reduc = 0;
	if (!empty($object->thirdparty->remise_percent)) {
		$reduc = $object->thirdparty->remise_percent;
	} */

	$sql = "SELECT fk_prod_attr, fk_prod_attr_val ";
	$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination2val as pacv ";
	$sql .= "INNER JOIN " . MAIN_DB_PREFIX . "product_attribute as pa ";
	$sql .= "ON pacv.fk_prod_attr = pa.rowid ";
	$sql .= "WHERE fk_prod_combination = (";
	$sql .= "SELECT DISTINCT rowid FROM ";
	$sql .= MAIN_DB_PREFIX . "product_attribute_combination ";
	$sql .= "WHERE fk_product_child = " . $product->id . " ";
	$sql .= "AND entity = " . $conf->entity . ") ";
	$sql .= "AND entity = " . $conf->entity;

	$arrayCombinations = array();
	$parentID = -1;

	$resql = $db->query($sql);
	if ($resql) {
		while ($attr = $db->fetch_object($resql)) {
			$arrayCombinations[$attr->fk_prod_attr] = $attr->fk_prod_attr_val;
		}
		$sql = "SELECT DISTINCT fk_product_parent ";
		$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination as pac ";
		$sql .= "WHERE fk_product_child = " . $product->id . " ";
		$sql .= "AND entity = " . $conf->entity;
		$resql = $db->query($sql);
		if ($resql) {
			while ($parent = $db->fetch_object($resql)) {
				$parentID = $parent->fk_product_parent;
			}
		}
		if ($parentID == -1) {
			$sql = "SELECT DISTINCT fk_product_parent ";
			$sql .= "FROM " . MAIN_DB_PREFIX . "product_attribute_combination as pac ";
			$sql .= "WHERE fk_product_parent = " . $product->id . " ";
			$sql .= "AND entity = " . $conf->entity;
			$resql = $db->query($sql);
			if ($resql) {
				while ($parent = $db->fetch_object($resql)) {
					$parentID = $parent->fk_product_parent;
				}
			}
		}
	}
	foreach ($listPrefixEcotax as $PrefixEcotax) {
		$enabled = preg_match('/' . trim($PrefixEcotax) . '(.*)/', $product->ref, $reg) ? ' disabled' : '';
		if (!empty($enabled)) {
			break;
		}
	}
	if ($product->status == 1) {
	?>
		<tr class="oddeven">
			<input type="hidden" name="ouvrage[product][<?php print $i ?>][id]" value="<?php print $det['id'] ?>"/>
			<td class="fk_parent" style="display: none"><input type="hidden" name="ouvrage[product][<?php print $i ?>][fk_parent]" value="<?php print $det['fk_parent'] ?>"/></td>
			<?php
			if ($conf->variants->enabled) {
				$conf->variants->enabled = 0;
				?>
				<td><?php print $form->select_produits($product->id, 'ouvrageProductID' . $i, 0,
						200000); ?></td>
				<?php
				$conf->variants->enabled = 1;
			} else {
				?>
				<td id="product-ref<?php print $i ?>"><?php print $product->ref ?></td>
			<?php } ?>
			<td id="product-label<?php print $i ?>" colspan="2"><?php print $product->label ?></td>
			<td class="product-stock right"><?php print(empty($enabled) ? $product->stock_reel : '') ?></td>

			<td class="product-tva<?php print $det['fk_parent'] ?> right">
				<?php
				if (!empty($conf->global->OUVRAGE_USE_LINE_VAT)) {
					$tva_tx = $product->tva_tx;
					print $form->load_tva("ouvrage[product][" . "$i" . "][tva]", $tva_tx);
				} else {
					print price2num($tva_tx, 'MT');
				}
				?>
			</td>
			<td class="product-price right">
				<input type="number" class="right" id="product-price<?php print $det['fk_parent'] ?>"
					   name="ouvrage[product][<?php print $i ?>][price_ht]"
					   value="<?php print price2num(floatval($pu_ht), 'MT') ?>" size="5" step="0.01" min="0"
					   style="max-width: 100px;" <?php print $enabled ?>/>
				<input type="hidden" name="ouvrage[product][<?php print $i ?>][price_ht]"
					   value="<?php print price2num(floatval($pu_ht), 'MT') ?>"/>
				<input type="hidden" name="ouvrage[product][<?php print $i ?>][order]"
					   value="<?php print $det['order'] ?>"/>
			</td>
			<td class="product-qty right">
				<input type="number" data-default="<?php print $det['default-qty'] ?>" class="right"
					   id="product-quantity-<?php print $det['fk_parent'] ?>"
					   name="ouvrage[product][<?php print $i ?>][qty]"
					   value="<?php print $det['qty'] ?>" size="2"
					   step="<?php print $conf->global->OUVRAGE_QUANTITY_STEP ?>" min="0"
					   style="max-width: 100px;" <?php print $enabled ?>/>
				<input type="hidden" name="ouvrage[product][<?php print $i ?>][qty]"
					   value="<?php print $det['qty'] ?>"/>
				<input type="hidden" name="ouvrage[product][<?php print $i ?>][qtysite]"
					   value="<?php print (!empty($qtySite) ? $qtySite : 0  )  ?>"/>
			</td>
			<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
				<td><?php print $form->selectUnits( (!empty($cond_id) ? $cond_id: $product->fk_unit),
						"ouvrage[product][" . $i . "][unit]", 1); ?></td>
			<?php } ?>
			<td class="product-reduc right">
				<input type="number" class="right" id="product-reduc<?php print $det['fk_parent'] ?>"
					   name="ouvrage[product][<?php print $i ?>][reduc]"
					   value="<?php print $reduc ?>"
					   size="2" step="0.01" min="0" max="100"
					   style="max-width: 50px;" <?php print $enabled ?>/><span class="hideonsmartphone">%</span>
				<input type="hidden" name="ouvrage[product][<?php print $i ?>][reduc]"
					   value="<?php print $reduc ?>"/>
			</td>
			<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
				<td class="product-marge<?php print $det['fk_parent'] ?> right">
					<input type="number" class="right" id="product-marge<?php print $i ?>"
						   name="ouvrage[product][<?php print $i ?>][marge]" value="" size="5"
						   step="0.01" min="0" data-product="<?php print $product->id ?>"
						   style="max-width: 100px;"/>
				</td>
			<?php } ?>
			<td class="product-price-total<?php print $det['fk_parent']?> right"
				id="product-price-total<?php print $i ?>"><?php print price2num((($pu_ht * $det['qty']) - ($pu_ht * ($reduc / 100) * $det['qty'])),
					'MT') ?></td>
			<?php if (!empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX)) { ?>
				<td class="product-check center">
					<input type="checkbox" id="product-check<?php print $i ?>" checked/>
					<input type="hidden" name="ouvrage[product][<?php print $i ?>][check]"
						   value="1"/>
				</td>
			<?php } ?>
		</tr>
	<?php if (!empty($conf->variants->enabled)) { ?>
		<tr class="oddeven" style="margin: 1%; margin-bottom: 2%;">
			<td colspan="<?php print $colspan ?>" id="variants_options_product<?php print $i; ?>"
				style="display: none !important;height: 75px;">
				<span id="variants_box<?php print $i; ?>"></span>
				<button type="button"
						id="addProduct<?php print $i; ?>"> <?php print $langs->transnoentitiesnoconv("Modify"); ?></button>
			</td>
		</tr>
		<script>
			console.log("debut script");
			selected = <?php print json_encode($arrayCombinations) ?>;
			combvalues = {};
			if ("<?php print $parentID; ?>" !== "-1") {
				$.getJSON("<?php print dol_buildpath('/variants/ajax/getCombinations.php', 2) ?>", {
					id: <?php print $parentID?>
				}, function (data) {
					$('#variants_box<?php print $i; ?>').empty();
					$.each(data, function (key, val) {
						combvalues[val.id] = val.values;
						var span = $("#variants_box<?php print $i; ?>");
						span = $(document.createElement('div')).text(val.label).css({
							'font-weight': 'bold',
							'display': 'table-cell',
							'text-align': 'right'
						});
						var html = $(document.createElement('select')).attr('name', 'combinations[' + val.id + ']').css({
							'margin-left': '15px',
							'margin-right': '15px',
							'white-space': 'pre'
						}).append(
							$(document.createElement('option')).val('')
						);
						selected = <?php print json_encode($arrayCombinations) ?>;
						$.each(combvalues[val.id], function (key, val) {
							var tag = $(document.createElement('option')).val(val.id).html(val.value);
							if (selected[val.fk_product_attribute] == val.id) {
								tag.attr('selected', 'selected');
							}
							html.append(tag);
						});
						span.append(html);
						$('#variants_box<?php print $i;?>').append(span);
					});
					$("#variants_options_product<?php print $i; ?>").show();
				});
			}
			$().ready(function () {
				if (<?php print $conf->variants->enabled ?>) {
					$("#search_ouvrageProductID<?php print $i ?>").prop("disabled", true);
				}
				$("#addProduct<?php print $i ?>").click(function () {
					$.getJSON("<?php print dol_buildpath('/variants/ajax/getCombinations.php', 2) ?>", {
							id: <?php print $parentID ?>
						},
						function (data) {
							var productREF = [];
							var nbNull = 0;
							for (i = data.length - 1; i >= 0; i--) {
								productREF[i] = $("#variants_box<?php print $i?> select[name='combinations[" + (i + 1) + "]']").val();
								if (productREF[i] == "") {
									nbNull++;
								}
							}
							if (nbNull == data.length) {
								productREF = null;
							}
							ajaxURL = "<?php print dol_buildpath("custom/ouvrage/ajax/getProduct.php", 1); ?>";
							$.ajax({
								url: ajaxURL,
								type: "POST",
								data: {
									"action": "getProductToAdd",
									"parentID": <?php print $parentID; ?>,
									"productREF": productREF,
									"socID": <?php print $object->socid; ?>,
								},
							}).done(function (data) {
								console.log("getProduct");
								data = JSON.parse(data);
								if (data.error != 0) {
									alert(data.message);
								} else {
									var valid = true;
									$('input[id^="ouvrageProductID"]').each(function () {
										if ($(this).val() === data.productID) {
											alert("<?php print $langs->transnoentitiesnoconv("OUVRAGE_PRODUCT_ALREADY_IN"); ?>");
											valid = false;
										}
									});
									if (!valid) {
										return;
									}
									$("#search_ouvrageProductID<?php print $i ?>").val(data.productREF);
									$("#ouvrageProductID<?php print $i ?>").val(data.productID);
									$("#product-label<?php print $i ?>").text(data.productLabel);
									$("#product-price<?php print $i ?>").val(data.productPrice);
									$("#product-price<?php print $i ?>").trigger("change");
									$("#product-price<?php print $i ?>").attr('name', 'ouvrage[product][' + data.productID + '][price_ht]');
									$("#product-quantity<?php print $i ?>").attr('name', 'ouvrage[product][' + data.productID + '][qty]');
									if ($("input[name='ouvrage[reduc]']").val() != 0) {
										$("#product-reduc<?php print $i ?>").val($("input[name='ouvrage[reduc]']").val());
									} else {
										$("#product-reduc<?php print $i ?>").val(data.productDiscount);
									}
									$("#product-reduc<?php print $i ?>").trigger("change");
									$("#product-reduc<?php print $i ?>").attr('name', 'ouvrage[product][' + data.productID + '][reduc]');
									$("#product-marge<?php print $i ?>").val(data.productCost);
									$("#product-marge<?php print $i ?>").trigger("change");
									$("#product-marge<?php print $i ?>").attr('name', 'ouvrage[product][' + data.productID + '][marge]');
								}
							}).fail(function () {
								alert("<?php print $langs->transnoentitiesnoconv("OUVRAGE_SERVER_ERROR"); ?>");
							});
						}
					);
				});
			});
			<?php if ($selected){ ?>
			$("#<?php print 'ouvrageProductID' . $i ?>").change();
			<?php } ?>
		</script>
		<?php
	}
	$i++;
	}
	}
	}
	?>
	</tbody>
</table>
<script>
	var url = "<?php print dol_buildpath('custom/ouvrage/ajax/getProduct.php', 1) ?>";

	function addProductOuvrage(productId) {
		console.log("addProductOuvrage");
		$.ajax({
			url: url,
			data: {
				"action": "getProductInformation",
				"productId": productId,
				"socID": <?php print $object->socid; ?>,
				"objID": <?php print ((!empty($object->array_options['options_isSitePropal'])&& dolibarr_get_const($db, 'OUVRAGE_SITE', $conf->entity) == 1) ?$object->id :0 ) ; ?>
			},
			type: 'POST'
		}).done(function (data) {
			data = JSON.parse(data);
			addLineNewProduct(data);
		}).fail(function () {
			//alert("ERROR");
		});
	}

	$(document).on("select2-selecting", '#newproductid', function (e) {

		var prodid = e.choice.id;
		console.log("totot")
		addProductOuvrage(prodid);
		setTimeout(function () {
			$('#newproductid').val(0).trigger('change');
		}, 20);

	});

	$(document).on("autocompleteselect", '#search_newproductid', function (event, ui) {
		var prodid = ui.item.id;

		addProductOuvrage(prodid);

		setTimeout(function () {
			$('#search_newproductid').val('').trigger('change');
		}, 20);
	});

</script>
<table id="tablefreelineouvrage" class="tagtable liste listwithfilterbefore noborder" width="100%">
	<thead>
	<tr class="liste_titre_filter">
		<td class="liste_titre" colspan="<?php print $colspan ?>"><?php print $langs->trans('OUVRAGE_AddNewProduct') ?>
			&nbsp;&nbsp;<?php print $form->select_produits('', 'newproductid', '', 200000); ?></td>
	</tr>
	<tr class="liste_titre nodrag nodrop">
		<th class="liste_titre center"><?php print $langs->trans('OUVRAGEProductType') ?></th>
		<th class="liste_titre center" colspan="3"><?php print $langs->trans('Description') ?></th>
		<th class="liste_titre center"><?php print $langs->trans('VAT') ?></th>
		<th class="liste_titre center"><?php print $langs->trans('PriceUHT') ?></th>
		<th class="liste_titre center"><?php print $langs->trans('Qty') ?></th>
		<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
			<th class="liste_titre center"><?php print $langs->trans('Unit') ?></th>
		<?php } ?>
		<th class="liste_titre center"><?php print $langs->trans('Discount') ?></th>
		<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
			<th class="liste_titre center"><?php print $langs->trans('CostPrice') ?></th>
		<?php } ?>
		<th class="liste_titre center" colspan="2">&nbsp;</th>
	</tr>
	</thead>
	<tbody>
	<tr class="oddeven">
		<td>
			<select class="flat" id="select_type_newproduct" name="type">
				<option value="-1" selected=""></option>
				<option value="0"><?php print $langs->trans('Product') ?></option>
				<option value="1"><?php print $langs->trans('Service') ?></option>
			</select>
		</td>
		<td colspan="3"><textarea id="desc_newproduct" name="desc_newproduct" class="flat"></textarea></td>
		<td>
			<?php
			$buyer = new Societe($db);
			$buyer->fetch(GETPOST('id', 'int'));
			print $form->load_tva('tva_tx_newproduct', -1, $mysoc, $buyer, 0, 0, '', false, 1);
			?>
		</td>
		<td><input type="text" class="flat right" id="price_ht_newproduct" name="price_ht_newproduct" value=""
				   size="5"/></td>
		<td><input type="text" class="flat right" id="qty_newproduct" name="qty_newproduct" value="1" size="2"/></td>
		<?php if (!empty($conf->global->PRODUCT_USE_UNITS)) { ?>
			<td><?php print $form->selectUnits('', "units_newproduct", 1); ?></td>
		<?php } ?>
		<td>
			<input type="text" class="flat right" id="remise_percent_newproduct" name="remise_percent_newproduct"
				   value="0" size="1"/>
			<span class="hideonsmartphone">%</span>
		</td>
		<?php if (!empty($conf->margin->enabled) && $user->rights->margins->creer) { ?>
			<td><input type="text" class="flat maxwidth75 maxwidth150 right" id="buying_price_newproduct"
					   name="buying_price_newproduct" value="0"></td>
		<?php } ?>
		<td class="center" colspan="2">
			<button id="addNewProduct"><?php print $langs->trans('OUVRAGE_AddNewProduct') ?></button>
		</td>
	</tr>
	</tbody>
</table>
<script>
	var nbNewProductAdded = 0;
	var selectUnit = '<?php print $form->selectUnits('', "newProductUnitStatic", 1); ?>';
	var selectVAT = '<?php print $form->load_tva('newProductVATStatic', '0,0'); ?>';

	function transformSelectUnit(fk_unit) {
		console.log("transformSelectUnit");
		var newSelect = selectUnit;
		newSelect = newSelect.replace('newProductUnitStatic', 'newProductUnit' + nbNewProductAdded);
		newSelect = newSelect.replace('newProductUnitStatic', 'ouvrage[newProduct][' + nbNewProductAdded + '][unit]');
		newSelect = newSelect.replace('value="' + fk_unit + '"', 'value="' + fk_unit + '" selected');
		return newSelect;
	}

	function transformSelectVAT(fk_tva) {
		console.log("transformSelectVAT");
		var newSelectVAT = selectVAT;
		newSelectVAT = newSelectVAT.replace('newProductVATStatic', 'newProductVAT' + nbNewProductAdded);
		newSelectVAT = newSelectVAT.replace('newProductVATStatic', 'ouvrage[newProduct][' + nbNewProductAdded + '][tva]');
		newSelectVAT = newSelectVAT.replace('value="' + fk_tva + '"', 'value="' + fk_tva + '" selected');
		return newSelectVAT;
	}

	function addLineNewProduct(values) {
		console.log("addLineNewProduct");
		var inputProductId = '<input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][productId]" value="' + values.productId + '">';
		var inputProductType = '<input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][productType]" value="' + values.productType + '">';
		var inputProductRef = '<input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][ref]" value="' + (values.ref ? values.ref : "") + '">';
		var inputProductLabel = values.ref ? '<input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][label]" value="' + values.label + '">' : '';
		var inputProductDescription = values.ref ? '' : '<input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][description]" value="' + values.description + '">';
		var tdRef = '<td id="newProductRef' + nbNewProductAdded + '">' + (values.ref ? values.ref : values.productType) + '</td>';
		var tdLabel = values.ref ? '<td colspan="2" id="newProductLabel' + nbNewProductAdded + '">' + values.label + '</td>' : '';
		var tdDescription = values.ref ? '' : '<td colspan="2" id="newProductDescription' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][description]">' + values.description + '</td>';
		var tdStock = '<td class="newProductStock right">' + parseFloat(values.stock).toFixed(2); + '</td>';
		if (<?php print((empty($conf->global->OUVRAGE_USE_LINE_VAT)) ? "false" : "true") ?>) {
			var tdVAT = '<td class="product-tva right" id="newProductVAT' + nbNewProductAdded + '">' + transformSelectVAT(values.vat) + '</td>';
		} else {
			var tdVAT = '<td class="product-tva right" id="newProductVAT' + nbNewProductAdded + '">' + $("#tva_tx_ouvrage").val() + '</td>';
		}
		var tdPrice = '<td class="product-price right"><input type="number" class="useForCalculation right" id="newProductPrice' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][price_ht]" value="' + values.price + '" size="5" min="0" step="0.01" style="max-width: 100px;"></td>';
		var tdQuantity = '<td class="product-qty right"><input type="number" class="useForCalculation right" id="newProductQuantity' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][qty]" data-default="' + values.quantity + '"value="' + values.quantity + '" size="2" step="1" min="0" style="max-width: 75px;"></td>';
		var tdUnit = "";
		if (<?php print((empty($conf->global->PRODUCT_USE_UNITS)) ? "false" : "true") ?>) {
			if (values.unit === undefined || values.unit == null) {
				values.unit = "";
				values.unitLabel = "";
			}
			tdUnit = '<td id="newProductUnit' + nbNewProductAdded + '">' + transformSelectUnit(values.unit) + '</td>';
		}
		var discount = $("input[name='ouvrage[reduc]']").val();
		if (discount != 0 ) {
			var tdDiscount = '<td class="product-reduc right"><input type="number" class="useForCalculation right" id="newProductDiscount' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][reduc]" value="' + discount + '" size="2" step="0.01" min="0" max="100" style="max-width: 50px;"><span class="hideonsmartphone">%</span></td>';
			var tdTotal = '<td class="product-price-total right" id="product-price-total' + nbNewProductAdded + '">' + ((values.price - (values.price * (discount / 100))) * values.quantity) + '</td>';
		} else {
			var tdDiscount = '<td class="product-reduc right"><input type="number" class="useForCalculation right" id="newProductDiscount' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][reduc]" value="' + values.discount + '" size="2" step="0.01" min="0" max="100" style="max-width: 50px;"><span class="hideonsmartphone">%</span></td>';
			var tdTotal = '<td class="product-price-total right" id="product-price-total' + nbNewProductAdded + '">' + ((values.price - (values.price * (values.discount / 100))) * values.quantity) + '</td>';
		}
		var tdBuyPrice = '';
		if (<?php print((!empty($conf->margin->enabled) && $user->rights->margins->creer) ? "true" : "false") ?>) {
			tdBuyPrice = '<td class="product-marge right"><input type="number" class="right" id="newProductBuyPrice' + nbNewProductAdded + '" name="ouvrage[newProduct][' + nbNewProductAdded + '][buyprice]" value="' + values.buyprice + '" size="5" step="0.01" min="0" style="max-width: 100px;"></td>';
		}

		var tdCheck = '';
		if (<?php print((!empty($conf->global->OUVRAGE_USE_LINE_CHECKBOX)) ? "true" : "false") ?>) {
			tdCheck = '<td class="product-check center"><input type="checkbox" id="newProduct-check' + nbNewProductAdded + '" checked /><input type="hidden" name="ouvrage[newProduct][' + nbNewProductAdded + '][check]" value="1"/></td>';
		}
		$("#tablelinesouvrage").append("<tr id='newProductLine" + nbNewProductAdded + "' class='oddeven'>" + inputProductId + inputProductType + inputProductRef + inputProductLabel + inputProductDescription + tdRef + tdLabel + tdDescription + tdStock + tdVAT + tdPrice + tdQuantity + tdUnit + tdDiscount + tdBuyPrice + tdTotal + tdCheck + "</tr>");
		let ouvrageTotalPU = parseFloat($("#tablelinesouvrage .ouvrage-price-unit").text());
		ouvrageTotalPU += parseFloat(values.price);
		$("#tablelinesouvrage .ouvrage-price-unit").text(parseFloat(ouvrageTotalPU).toFixed(<?php print $conf->global->MAIN_MAX_DECIMALS_TOT; ?>));
		calculTotalOuvrage();
		nbNewProductAdded++;
	}

	function verifyValueIsEmpty(values) {
		const isEmpty = (element) => (element.trim().length === 0 || element == '-1');
		return values.some(isEmpty);
	}

	function verifyValueIsNumber(values) {
		const isNumber = (element) => (!isNaN(element) && element.trim().length > 0);
		return values.every(isNumber);
	}

	function addNewProductOuvrage() {
		console.log("addNewProductOuvrage");
		var productType = $("#select_type_newproduct").val();
		var productDescription = $("#desc_newproduct").val();
		var productVAT = $("#tva_tx_newproduct").val();
		var productPrice = $("#price_ht_newproduct").val();
		var productQuantity = $("#qty_newproduct").val();
		var productUnit = null;
		var productUnitLabel = null;
		if (<?php print((empty($conf->global->PRODUCT_USE_UNITS)) ? "false" : "true") ?>) {
			productUnit = $("#units_newproduct").val();
		}
		var productDiscount = $("#remise_percent_newproduct").val();
		var productBuyPrice = $("#buying_price_newproduct").val();
		if (productBuyPrice === undefined) {
			productBuyPrice = '0.0';
		}
		var toVerifyNumber = [productPrice, productQuantity, productBuyPrice, productDiscount, productVAT];
		var toVerifyEmpty = [productType, productDescription];
		toVerifyNumber = toVerifyNumber.map(function (v) {
			return v.replace(",", ".")
		});
		let isNumber = verifyValueIsNumber(toVerifyNumber);
		let isEmpty = verifyValueIsEmpty(toVerifyEmpty);
		if (isNumber && !isEmpty) {
			let values = {
				"productId": "",
				"productType": productType,
				"label": "",
				"description": productDescription,
				"stock": "",
				"vat": toVerifyNumber[4],
				"price": toVerifyNumber[0],
				"quantity": toVerifyNumber[1],
				"unit": productUnit,
				"buyprice": toVerifyNumber[2],
				"discount": toVerifyNumber[3]
			}
			addLineNewProduct(values);
		}
	}

	function fillOuvrageDescTextArea(){
		let ouvrageDescription = $('#cke_ouvrageDescription').find('iframe').contents().find('body').html()
		ouvrageDescription = customHTMLEncode(ouvrageDescription);
		$('input[name=\"ouvrage[desc]\"]').val( ouvrageDescription);
	};

	function customHTMLEncode(str) {
		return str.replace(/&/g, '&amp;')
			.replace(/</g, '&lt;')
			.replace(/>/g, '&gt;')
			.replace(/"/g, '&quot;')
			.replace(/'/g, '&#039;');
	};
	$('#addNewProduct').click(function () {
		addNewProductOuvrage();
	});
	$( document ).ready(function() {
		console.log( "ready!" );
		$('#tablelinesouvrage td.product-reduc input').trigger('change');
	});
</script>
