<?php
if (!defined('NOCSRFCHECK')) {
	define('NOCSRFCHECK', '1');
}
// Load Dolibarr environment
$res = 0;
if (!$res && file_exists("../main.inc.php")) {
	$res = @include '../main.inc.php';
}     // to work if your module directory is into dolibarr root htdocs directory
if (!$res && file_exists("../../main.inc.php")) {
	$res = @include '../../main.inc.php';
}   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../main.inc.php")) {
	$res = @include '../../../main.inc.php';
}   // to work if your module directory is into a subdir of root htdocs directory
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../dolibarr/htdocs/main.inc.php';
}     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php")) {
	$res = @include '../../../../dolibarr/htdocs/main.inc.php';
}   // Used on dev env only
if (!$res) {
	die("Include of main fails");
}

require_once DOL_DOCUMENT_ROOT.'/core/lib/functions.lib.php';	// InfraS add
require_once DOL_DOCUMENT_ROOT.'/product/class/product.class.php';	// InfraS change
require_once DOL_DOCUMENT_ROOT.'/societe/class/societe.class.php';	// InfraS add
require_once DOL_DOCUMENT_ROOT.'/variants/class/ProductCombination.class.php';	// InfraS change
dol_include_once('/ouvrage/class/ouvrage.class.php');	// InfraS change

global $db, $user, $mysoc, $langs;

$action = GETPOST("action");
$parentID = GETPOST("parentID");
$productREF = GETPOST("productREF");
$socID = GETPOST("socID");
$objID = GETPOST("objID");

$productID = GETPOST("productId");
$productUnit = GETPOST("fk_unit");

function resetIndex($productREF)
{
	$return = array();
	for ($i = 0; $i < count($productREF); $i++) {
		if (!empty($productREF[$i])) {
			$return[$i + 1] = $productREF[$i];
		}
	}

	return $return;
}

if ($action == "getProduct") {
	if ($parentID == null) {
		$response = array(
			"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PARENT_ID_WAS_PASSED"),
			"error" => 1,
		);
		echo json_encode($response);
		exit();
	}

	if ($productREF != null) {
		$productCombination = new ProductCombination($db);
		$productCombination = $productCombination->fetchByProductCombination2ValuePairs($parentID,
			resetIndex($productREF));

		$product = new Product($db);
		$product->fetch($productCombination->fk_product_child);
		if ($product->id != null) {
			$response = array(
				"productID" => $product->id,
				"productLabel" => $product->ref . ( (!empty($product->ref) && !empty($product->label)) ? " - " : ""  ). $product->label,
				"error" => 0,
			);
		} else {
			$response = array(
				"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PRODUCT_FOUND"),
				"error" => 2,
			);
		}
	} else {
		$product = new Product($db);
		$product->fetch($parentID);
		if ($product->id != null) {
			$response = array(
				"productID" => $product->id,
				"productLabel" => $product->ref . ( (!empty($product->ref) && !empty($product->label)) ? " - " : ""  ). $product->label,
				"error" => 0,
			);
		} else {
			$response = array(
				"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PRODUCT_FOUND"),
				"error" => 3,
			);
		}
	}

	echo json_encode($response);
	exit();
}

if ($action == "getProductToAdd") {
	$soc = new Societe($db);
	$soc->fetch($socID);

	if ($parentID == -1) {
		$response = array(
			"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PRODUCT_REF_WAS_PASSED"),
			"error" => 1,
		);
		echo json_encode($response);
		exit();
	}

	if ($productREF != null) {
		$productCombination = new ProductCombination($db);
		$productCombination = $productCombination->fetchByProductCombination2ValuePairs($parentID,
			resetIndex($productREF));

		$product = new Product($db);
		$product->fetch($productCombination->fk_product_child);

		if ($product->id != null) {
			if ((int) DOL_VERSION <= 9) {
				if (!empty($conf->global->PRODUIT_CUSTOMER_PRICES)) {
					require_once DOL_DOCUMENT_ROOT . '/product/class/productcustomerprice.class.php';

					$prodcustprice = new Productcustomerprice($db);

					$filter = array('t.fk_product' => $prod->id, 't.fk_soc' => $object->thirdparty->id);

					$result = $prodcustprice->fetch_all('', '', 0, 0, $filter);
					if ($result) {
						if (count($prodcustprice->lines) > 0) {
							$productPrice = price($prodcustprice->lines[0]->price);
						}
					}
				} else {
					$productPrice = $product->price;
				}
			} else {
				$productPrice = price2num($product->getSellPrice($mysoc, $soc)["pu_ht"], 2);
			}
			$response = array(
				"productID" => $product->id,
				"productREF" => $product->ref,
				"productLabel" => $product->label,
				"productPrice" => $productPrice,
				"productDiscount" => (($soc->remise_percent == null) ? 0 : $soc->remise_percent),
				"productCost" => (($product->cost_price == null) ? 0 : $product->cost_price),
				"error" => 0,
			);
		} else {
			$response = array(
				"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PRODUCT_FOUND"),
				"error" => 2,
			);
		}
	} else {
		$product = new Product($db);
		$product->fetch($parentID);
		if ($product->id != null) {
			$response = array(
				"productID" => $product->id,
				"productREF" => $product->ref,
				"productLabel" => $product->ref . ( (!empty($product->ref) && !empty($product->label)) ? " - " : ""  ). $product->label,
				"error" => 0,
			);
		} else {
			$response = array(
				"message" => $langs->transnoentitiesnoconv("OUVRAGE_NO_PRODUCT_FOUND"),
				"error" => 3,
			);
		}
	}

	echo json_encode($response);
	exit();
}

if ($action == "getProductInformation") {
	require_once DOL_DOCUMENT_ROOT.'/comm/propal/class/propal.class.php';
	if (empty($productID)) {
		$response = array(
			"error" => 1,
		);
		echo json_encode($response);
		exit();
	}

	$thirdparty = new Societe($db);
	$thirdparty->fetch($socID);
	$product = new Product($db);
	$product->fetch($productID);

	$tva_tx = get_default_tva($mysoc, $thirdparty, $product->id);	// InfraS add
	$tva = preg_replace('/0+$/', '', $tva_tx);	// InfraS change
	$tva = preg_replace('/\.$/', '', $tva);

	if (!empty($objID)) {
		$obj = new Propal($db);
		$obj->fetch($objID);
		$product->fetch_optionals();
		$qtySite = $product->array_options['options_qty'];
		$reduc = 0;
		// COMPTATIBILITE MODULE DISCOUNT RULE : RECHERCHE DE REGLE DE TARIFICATION
		if (!empty($conf->discountrules->enabled) ){
			if(!class_exists('DiscountSearch')){ dol_include_once('/discountrules/class/discountSearch.class.php'); }
			if(class_exists('DiscountSearch')) { // Il est possible que le module soit supprimé mais pas désinstallé
				$discountSearch = new DiscountSearch($db);
				$subprice = DiscountRule::getProductSellPrice($product->id, $obj->thirdparty->id);
				$discountSearchResult = $discountSearch->search('0', $product->id,$obj->thirdparty->id, $fk_project);
				if ($discountSearchResult->result) {
					// Mise en page du résultat
					$discountSearchResult->tpMsg = getDiscountRulesInterfaceMessageTpl($langs, $discountSearchResult, $action);
					$subprice = $discountSearchResult->subprice;
					$finalSubprice = $discountSearchResult->calcFinalSubprice();

					if (!empty($discountSearchResult->reduction)) {
						$discount = $discountSearchResult->reduction;
					}
				}
			}
			else{
				setEventMessage($langs->trans('ErrorMissingModuleDiscountRule'));
			}
		}

		$cond = $product->array_options['options_cond'];
		if (!empty($cond)) {
			$sql = 'SELECT r.rowid FROM '.MAIN_DB_PREFIX.'c_units r WHERE short_label = "'.$cond.'"';
			$resql = $db->query($sql);
			$obj = $db->fetch_object($resql);
			$cond_id = $obj->rowid;
		}


		if(!empty($subprice)) {
			$pu_ht = $subprice;
		}
		if (!empty($qtySite)) {
			$pu_ht = $pu_ht /$qtySite;
		}
	} else {
		$pu_ht = price2num($product->price, 'MT');
		$discount = 0;
		$cond_id = $product->fk_unit;
	}



	$response = array(
		"productId" => $product->id,
		"productType" => $product->type,
		"ref" => $product->ref,	// InfraS change
		"label" => $product->label,	// InfraS change
		"stock" => (($product->stock_reel <= 0) ? 0 : $product->stock_reel),
		"unit" => $cond_id,
		"vat" => $tva,
		"price" => price2num($pu_ht, 'MT'),
		"discount" => $discount,
		"quantity" => 1,
		"buyprice" => ((empty($product->cost_price)) ? 0 : price2num($product->cost_price, 'MT')),	// InfraS change
		"error" => 0,
	);
	echo json_encode($response);
	exit();
}

if ($action == "getProductUnit") {
	$langs->load("products");

	if (empty($productUnit)) {
		$response = array(
			"error" => 1,
		);
		echo json_encode($response);
		exit();
	}

	$ouvrage = new Ouvrage($db);

	$response = array(
		"unitLabel" => $langs->trans($ouvrage->getUnitLabel('long', $productUnit)),
		"error" => 0,
	);
	echo json_encode($response);
	exit();
}
